# coding: utf-8

"""
    Lightly API

    Lightly.ai enables you to do self-supervised learning in an easy and intuitive way. The lightly.ai OpenAPI spec defines how one can interact with our REST API to unleash the full potential of lightly.ai  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@lightly.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from lightly.openapi_generated.swagger_client.configuration import Configuration


class CreateDockerWorkerRegistryEntryRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'DockerWorkerName',
        'worker_type': 'DockerWorkerType',
        'labels': 'DockerWorkerLabels',
        'creator': 'Creator',
        'docker_version': 'str'
    }

    attribute_map = {
        'name': 'name',
        'worker_type': 'workerType',
        'labels': 'labels',
        'creator': 'creator',
        'docker_version': 'dockerVersion'
    }

    def __init__(self, name=None, worker_type=None, labels=None, creator=None, docker_version=None, _configuration=None):  # noqa: E501
        """CreateDockerWorkerRegistryEntryRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._name = None
        self._worker_type = None
        self._labels = None
        self._creator = None
        self._docker_version = None
        self.discriminator = None

        self.name = name
        self.worker_type = worker_type
        if labels is not None:
            self.labels = labels
        if creator is not None:
            self.creator = creator
        if docker_version is not None:
            self.docker_version = docker_version

    @property
    def name(self):
        """Gets the name of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501


        :return: The name of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501
        :rtype: DockerWorkerName
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CreateDockerWorkerRegistryEntryRequest.


        :param name: The name of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501
        :type: DockerWorkerName
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def worker_type(self):
        """Gets the worker_type of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501


        :return: The worker_type of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501
        :rtype: DockerWorkerType
        """
        return self._worker_type

    @worker_type.setter
    def worker_type(self, worker_type):
        """Sets the worker_type of this CreateDockerWorkerRegistryEntryRequest.


        :param worker_type: The worker_type of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501
        :type: DockerWorkerType
        """
        if self._configuration.client_side_validation and worker_type is None:
            raise ValueError("Invalid value for `worker_type`, must not be `None`")  # noqa: E501

        self._worker_type = worker_type

    @property
    def labels(self):
        """Gets the labels of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501


        :return: The labels of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501
        :rtype: DockerWorkerLabels
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this CreateDockerWorkerRegistryEntryRequest.


        :param labels: The labels of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501
        :type: DockerWorkerLabels
        """

        self._labels = labels

    @property
    def creator(self):
        """Gets the creator of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501


        :return: The creator of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501
        :rtype: Creator
        """
        return self._creator

    @creator.setter
    def creator(self, creator):
        """Sets the creator of this CreateDockerWorkerRegistryEntryRequest.


        :param creator: The creator of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501
        :type: Creator
        """

        self._creator = creator

    @property
    def docker_version(self):
        """Gets the docker_version of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501


        :return: The docker_version of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501
        :rtype: str
        """
        return self._docker_version

    @docker_version.setter
    def docker_version(self, docker_version):
        """Sets the docker_version of this CreateDockerWorkerRegistryEntryRequest.


        :param docker_version: The docker_version of this CreateDockerWorkerRegistryEntryRequest.  # noqa: E501
        :type: str
        """

        self._docker_version = docker_version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateDockerWorkerRegistryEntryRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateDockerWorkerRegistryEntryRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateDockerWorkerRegistryEntryRequest):
            return True

        return self.to_dict() != other.to_dict()
