# coding: utf-8

"""
    Lightly API

    Lightly.ai enables you to do self-supervised learning in an easy and intuitive way. The lightly.ai OpenAPI spec defines how one can interact with our REST API to unleash the full potential of lightly.ai  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@lightly.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from lightly.openapi_generated.swagger_client.configuration import Configuration


class DockerWorkerConfigV3Data(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'MongoObjectID',
        'version': 'str',
        'config': 'DockerWorkerConfigV3',
        'config_orig': 'DockerWorkerConfigV3',
        'created_at': 'Timestamp'
    }

    attribute_map = {
        'id': 'id',
        'version': 'version',
        'config': 'config',
        'config_orig': 'configOrig',
        'created_at': 'createdAt'
    }

    def __init__(self, id=None, version=None, config=None, config_orig=None, created_at=None, _configuration=None):  # noqa: E501
        """DockerWorkerConfigV3Data - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._version = None
        self._config = None
        self._config_orig = None
        self._created_at = None
        self.discriminator = None

        self.id = id
        if version is not None:
            self.version = version
        self.config = config
        if config_orig is not None:
            self.config_orig = config_orig
        if created_at is not None:
            self.created_at = created_at

    @property
    def id(self):
        """Gets the id of this DockerWorkerConfigV3Data.  # noqa: E501


        :return: The id of this DockerWorkerConfigV3Data.  # noqa: E501
        :rtype: MongoObjectID
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DockerWorkerConfigV3Data.


        :param id: The id of this DockerWorkerConfigV3Data.  # noqa: E501
        :type: MongoObjectID
        """
        if self._configuration.client_side_validation and id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def version(self):
        """Gets the version of this DockerWorkerConfigV3Data.  # noqa: E501


        :return: The version of this DockerWorkerConfigV3Data.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this DockerWorkerConfigV3Data.


        :param version: The version of this DockerWorkerConfigV3Data.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def config(self):
        """Gets the config of this DockerWorkerConfigV3Data.  # noqa: E501


        :return: The config of this DockerWorkerConfigV3Data.  # noqa: E501
        :rtype: DockerWorkerConfigV3
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this DockerWorkerConfigV3Data.


        :param config: The config of this DockerWorkerConfigV3Data.  # noqa: E501
        :type: DockerWorkerConfigV3
        """
        if self._configuration.client_side_validation and config is None:
            raise ValueError("Invalid value for `config`, must not be `None`")  # noqa: E501

        self._config = config

    @property
    def config_orig(self):
        """Gets the config_orig of this DockerWorkerConfigV3Data.  # noqa: E501


        :return: The config_orig of this DockerWorkerConfigV3Data.  # noqa: E501
        :rtype: DockerWorkerConfigV3
        """
        return self._config_orig

    @config_orig.setter
    def config_orig(self, config_orig):
        """Sets the config_orig of this DockerWorkerConfigV3Data.


        :param config_orig: The config_orig of this DockerWorkerConfigV3Data.  # noqa: E501
        :type: DockerWorkerConfigV3
        """

        self._config_orig = config_orig

    @property
    def created_at(self):
        """Gets the created_at of this DockerWorkerConfigV3Data.  # noqa: E501


        :return: The created_at of this DockerWorkerConfigV3Data.  # noqa: E501
        :rtype: Timestamp
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this DockerWorkerConfigV3Data.


        :param created_at: The created_at of this DockerWorkerConfigV3Data.  # noqa: E501
        :type: Timestamp
        """

        self._created_at = created_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DockerWorkerConfigV3Data, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DockerWorkerConfigV3Data):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DockerWorkerConfigV3Data):
            return True

        return self.to_dict() != other.to_dict()
